proyecto-taller-info/config/routes.rb
Rails.application.routes.draw do

  resources :people
  devise_for :users

  resources :users
  resources :companies
  resources :projects
  resources :legal_agents

  get '' => 'static_pages#home'
  get '/users/annul/:id' => 'users#annul'
  get '/users/activate/:id' => 'users#activate'
  get 'error' => 'static_pages#error'
  post '/createuser' => 'users#create'

end

proyecto-taller-info/app/models/legal_agent.rb
class LegalAgent < ActiveRecord::Base
  	
  	belongs_to :user
  	belongs_to :company

	validates :identification_number, presence: {:message => ' no debe dejarse en blanco'}
	validates :identification_number, numericality: { only_integer: true, message: ' debe ser un numero' }
	validates :identification_number, uniqueness: { only_integer: true, message: ' no debe repetirse' }
	# validates :identification_type, presence: {:message => ' no debe dejarse en blanco'}
	validates :first_name, presence: {:message => ' no debe dejarse en blanco'}
	validates :last_name, presence: {:message => ' no debe dejarse en blanco'}
	validates :country, presence: {:message => ' no debe dejarse en blanco'}
	validates :city, presence: {:message => ' no debe dejarse en blanco'}
	validates :address, presence: {:message => ' no debe dejarse en blanco'}
	validates :phone_number, presence: {:message => ' no debe dejarse en blanco'}
	validates :phone_number, numericality: { only_integer: true, message: ' debe ser un numero' }
#	validates :mailbox, presence: {:message => ' (Codigo Postal) no debe dejarse en blanco.'}

	def self.search(search)
		where('first_name LIKE :search OR last_name LIKE :search', search:"%#{search}%")
	end

end

proyecto-taller-info/app/controllers/legal_agents_controller.rb
class LegalAgentsController < ApplicationController
  before_action :set_legal_agent, only: [:show, :edit, :update, :destroy]

  # GET /legal_agents
  # GET /legal_agents.json
  def index
    @legal_agents = LegalAgent.all

    if params[:search]
      @legal_agents = LegalAgent.search(params[:search]).order('created_at DESC')
    else
      @legal_agents = LegalAgent.all.order('created_at ASC')
    end

  end

  # GET /legal_agents/1
  # GET /legal_agents/1.json
  def show
  end

  # GET /legal_agents/new
  def new
    @legal_agent = LegalAgent.new
    @users = User.all
    @companies = Company.all
  end

  # GET /legal_agents/1/edit
  def edit
    @users = User.all
    @companies = Company.all
  end

  # POST /legal_agents
  # POST /legal_agents.json
  def create
    @legal_agent = LegalAgent.new(legal_agent_params)
    @users = User.all
    @companies = Company.all
    respond_to do |format|
      if @legal_agent.save
        format.html { redirect_to @legal_agent, notice: 'Representante Legal creado exitosamente' }
        format.json { render :show, status: :created, location: @legal_agent }
      else
        format.html { render :new }
        format.json { render json: @legal_agent.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /legal_agents/1
  # PATCH/PUT /legal_agents/1.json
  def update
    @users = User.all
    @companies = Company.all
    respond_to do |format|
      if @legal_agent.update(legal_agent_params)
        format.html { redirect_to @legal_agent, notice: 'Representante Legal actualizado exitosamente' }
        format.json { render :show, status: :ok, location: @legal_agent }
      else
        format.html { render :edit }
        format.json { render json: @legal_agent.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /legal_agents/1
  # DELETE /legal_agents/1.json
  def destroy
    @legal_agent.destroy
    respond_to do |format|
      format.html { redirect_to legal_agents_url, notice: 'Representante Legal eliminado' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_legal_agent
      @legal_agent = LegalAgent.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def legal_agent_params
      params.require(:legal_agent).permit(:identification_number, :identification_type, :first_name, :last_name, :country, :city, :address, :phone_number, :email, :mailbox, :user_id, :company_id)
    end
end

proyecto-taller-info/app/helpers/legal_agents_helper.rb
module LegalAgentsHelper
end

proyecto-taller-info/app/views/legal_agents/_form.html.erb
<%= form_for(@legal_agent) do |f| %>
  <% if @legal_agent.errors.any? %>
    <div class="col-md-3"></div>
    <div class="col-md-6">

      <div class="panel panel-danger">
        <div class="panel-heading">Errores al registrar compañia</div>
          <ul class="list-group">
            <% @legal_agent.errors.full_messages.each do |message| %>
              <li class='list-group-item'><%= message %></li>
            <% end %>
          </ul>
      </div>
    </div>
  <% end %>
<br>

<div class="row">
  <div class="col-md-6">  
    <div class="field">
      <label>Numero de Identificacion</label><br>
      <%= f.number_field :identification_number, :class => 'form-control' %>
    </div><br>
    <!--<div class="field">-->
      <!--<label>Tipo de identificacion</label><br>-->
      <!--<select name='legal_agent[identification_type]' class="form-control">-->
        <!--<option value="1">Carnet de Identidad</option>-->
        <!--<option value="2">Libreta Militar</option>-->
        <!--<option value="3">Pasaporte</option>-->
      <!--</select>-->
    <!--</div><br>-->
    <div class="field">
      <label>Nombre</label><br>
      <%= f.text_field :first_name, :class => 'form-control' %>
    </div><br>
    <div class="field">
      <label>Apellido</label><br>
      <%= f.text_field :last_name, :class => 'form-control' %>
    </div><br>
    <div class="field">
      <label>Pais</label><br>
      <%= f.text_field :country, :class => 'form-control' %>
    </div><br>
    <div class="field">
      <label>Ciudad</label><br>
      <%= f.text_field :city, :class => 'form-control' %>
    </div><br>
    <br>
      <p>* Todos los campos son obligatorios.</p>
  </div>

  <div class="col-md-6">  
    <div class="field">
      <label>Direccion</label><br>
      <%= f.text_field :address, :class => 'form-control' %>
    </div><br>
    <div class="field">
      <label>Numero de telefono</label><br>
      <%= f.text_field :phone_number, :class => 'form-control' %>
    </div><br>
  <!--  <div class="field">
      <label>Email</label><br>
      <%= f.text_field :email, :class => 'form-control' %>
    </div><br>
    <div class="field">
      <!--<%= f.label :mailbox %><br>-->
      <!--<%= f.text_field :mailbox, :class => 'form-control' %>-->
    <!--</div><br>-->
      <div class="field">
        <label>Cuenta de usuario</label><br>
        <%= f.select :user_id, options_from_collection_for_select(@users, "id", "email",@legal_agent.user_id), { :prompt => 'Ninguno'}, :class => 'form-control'  %>
      </div><br>
      <div class="field">
        <label>Compania</label><br>
        <%= f.select :company_id, options_from_collection_for_select(@companies, "id", "name") , {}, :class => 'form-control'%>
      </div><br>
  </div>
</div>
<div class="row center">
  <br>
    <% if !@companies.any? %>
        <p> *Tomar en cuenta que se necesita una compania para registrar un Representante Legal y en este momento 
        no hay companias registradas. </p>
    <% else %>
        <div class="actions">
          <%= f.submit 'Registrar',class: 'btn btn-default ' %>
        </div>
    <% end %>
</div>
<br>
<% end %>

proyecto-taller-info/app/views/legal_agents/edit.html.erb
<h1>Editar informacion de representante legal</h1>

<%= render 'form' %>

<!--<%= link_to 'Show', @legal_agent %> |
<%= link_to 'Back', legal_agents_path %>-->

proyecto-taller-info/app/views/legal_agents/index.html.erb
<p id="notice"><%= notice %></p>

<div class="row">
  <div class="col-md-7">
    <h1>Listado de Representantes Legales </h1>
    <br>
  </div>
  <div class="col-md-5">
      <%= render :partial => 'legal_agents/search' %>
      <div class="form-inline">
        <br>
        <%= form_tag( legal_agents_path , :method => "get", id: "search-form") do %>
            <%= text_field_tag :search, params[:search], placeholder: "Buscar", :class=>'form-control' %>
            <%= submit_tag "Buscar" ,:class=>'btn btn-default'%>
        <% end %>
      </div>
  </div>
</div>

<%if not @legal_agents.present? %>
  <%if params[:search]%>
     <h4>Su busqueda no generó resultados</h4>
  <%else%>
     <h4>No existen Representantes Legales en este momento</h4>
  <%end%>
<%else%>
  <br>
    <h4>Haga click en el numero de identificacion del representante legal para ver detalles</h4>
  <br>
  <table class="table table-striped">
    <thead>
      <tr>
        <th>Numero de Identificacion </th>
        <!--<th>Tipo de Identificacion</th>-->
        <th>Nombre</th>
        <th>Apellido</th>
        <!--<th>Pais</th>
        <th>Ciudad</th>
        <th>Direccion</th>-->
        <th>Telefono</th>
        <th>Email</th>
        <!--<th>Buzon de mensajes</th>
        <th>Usuario</th>-->
        <th>Compania</th>
        <th colspan="3"></th>
      </tr>
    </thead>

    <tbody>
      <% @legal_agents.each do |legal_agent| %>
        <tr>
          <td><%= link_to legal_agent.identification_number, legal_agent %></td>
          <!--<td><% if legal_agent.identification_type == 1 %>
                <p> Carnet de Identidad </p>
            <% elsif legal_agent.identification_type == 2 %>
                <p> Libreta Militar </p>
            <% else %>
                <p> Passaporte </p>
            <% end %></td>-->
          <td><%= legal_agent.first_name %></td>
          <td><%= legal_agent.last_name %></td>
          <!--<td><%= legal_agent.country %></td>
          <td><%= legal_agent.city %></td>
          <td><%= legal_agent.address %></td>-->
          <td><%= legal_agent.phone_number %></td>
          <td><%= legal_agent.email %></td>
          <!--<td><%= legal_agent.mailbox %></td>
          <td><%= if legal_agent.user then legal_agent.user.email else 'Se debe asignar cuenta de ususario' end %></td>-->
          <td><%= legal_agent.company.name %></td>
          <!--<td><%= link_to 'Ver representante legal', legal_agent %></td>-->
          <td><%= link_to 'Editar', edit_legal_agent_path(legal_agent) %></td>
          <td><%= link_to 'Eliminar', legal_agent, method: :delete, data: { confirm: 'Confirmacion' } %></td>
        </tr>
      <% end %>
    </tbody>
  </table>
<%end%>

<br>


<!--<%= link_to 'New Legal agent', new_legal_agent_path %>-->

proyecto-taller-info/app/views/legal_agents/new.html.erb
<h1>Registrar Representante Legal</h1>



  <%= render 'form' %>


<!--<%= link_to 'Back', legal_agents_path %>-->

proyecto-taller-info/app/views/legal_agents/show.html.erb
<p id="notice"><%= notice %></p>

<h1>Representante legal</h1>

<div class="jumbotron">
  <table class="table">
    <tr>
      <td> <strong>Nombre:</strong> </td>
      <td> <%= @legal_agent.first_name %> </td>
      <td> <strong>Apellido:</strong> </td>
      <td> <%= @legal_agent.last_name %> </td>
    </tr>

    <tr>
      <td> <strong>Numero de identificacion:</strong> </td>
      <td> <%= @legal_agent.identification_number %> </td>

      <!--<d>-> </td>
      <td> <!--<strong>Tipo de indentificacion: </strong>-->   <!--<% if @legal_agent.identification_type == 1 %>-->
          <!--Carnet de Identidad-->
        <!--<% elsif @legal_agent.identification_type == 2 %>-->
          <!--Libreta Militar-->
        <!--<% else %>-->
          <!--Passaporte-->
        <!--<% end %>-->
      <!--</td>-->

      <td> <strong>Pais:</strong> </td>
      <td> <%= @legal_agent.country %> </td>
    </tr>

    <tr>
      <td> <strong>Ciudad:</strong> </td>
      <td> <%= @legal_agent.city %> </td>
      <td> <strong>Direccion:</strong> </td>
      <td> <%= @legal_agent.address %> </td>
    </tr>

    <tr>
      <td> <strong>Telefono:</strong> </td>
      <td> <%= @legal_agent.phone_number %> </td>
      <td> <strong>Cuenta de usuario:</strong> </td>
      <td> <%= if @legal_agent.user then @legal_agent.user.email else 'Usuario sin asignar' end %> </td> 
    </tr>

      <!--<p>-->
        <!--<strong>Mailbox:</strong>-->
        <!--<%= @legal_agent.mailbox %>-->
      <!--</p>-->

    <tr>
      <td> <strong>Compania:</strong> </td>
      <td> <%= @legal_agent.company.name %> </td>
    </tr>
  </table>
</div>

<%= link_to 'Editar', edit_legal_agent_path(@legal_agent), :class=>'btn btn-primary'%> 
<%= link_to 'Volver', legal_agents_path, :class=>'btn btn-default'%>